package unstrip;

my %ALLOWED_FORMS_DEVIATIONS= ( "-LRB-" => "(", "-RRB-" => ")", "-LCB-" => "{", "-RCB-" => "}", "-LSB-" => "[", "-RSB-" => "]", "When" => "nullp" );

sub joinLine {
    my $conllLine=shift;
    my $strippedLine=shift;
    my @cc=split(/\s+/,$conllLine);
    my @sc=split(/\t/,$strippedLine);
    sameForms($sc[1],$cc[3]) or  die("not equal forms : $sc[1] -- $cc[3]");
    my $posTag=$cc[4]; #Change this to $sc[5] for pred pos by mate-tools, sc[4] for gold tag
#    $posTag=$sc[5];
    my $depHead=$sc[9]; #Set to 8 for gold
    my $depLabel=$sc[11]; #Set to 10 for gold
    my @out=($cc[0],$cc[1],$cc[2],$cc[3],$posTag,$cc[5],$cc[6],$cc[7],$cc[8],$cc[9],$cc[10],$depHead,$depLabel);
    #push the srl cols
    for(my $i=11,my $max=scalar(@cc)-1;$i<$max;++$i){
	push @out,$cc[$i];
    }
    push @out,$cc[-1];
    my $outLine = join("\t",@out) . "\n";
    return $outLine;
}

sub sameForms {
    my $a=shift;
    my $b=shift;
    if($a ne $b){
	my $qa=$a;
	my $qb=$b;
	$qa=~s/-LRB-/\(/g;
	$qa=~s/-RRB-/\)/g;
	$qb=~s/-LRB-/\(/g;
	$qb=~s/-RRB-/\)/g;
	if($qa eq $qb || (defined($ALLOWED_FORMS_DEVIATIONS{$a} && $ALLOWED_FORMS_DEVIATIONS{$a} eq $b) || defined($ALLOWED_FORMS_DEVIATIONS{$b} && $ALLOWED_FORMS_DEVIATIONS{$b} eq $a))){
	    return 1;
	} else {
	    print "'$a' -- $b\n";
	    return 0;
	}
    }
    return 1;
}


1;
