package ims.coref.features;

import ims.coref.data.Document;
import ims.coref.data.PairInstance;
import ims.coref.data.Span;
import ims.coref.features.extractors.TargetSpanExtractor;

public class F_DepDominatingVerb  extends AbstractSingleDataDrivenFeature {
	private static final long serialVersionUID = -7665773109266573274L;

	private final boolean withDirection;
	private final TargetSpanExtractor tse;
	
	
	protected F_DepDominatingVerb(TargetSpanExtractor tse, boolean withDirection,int cutOff){
		super(tse.ts.toString()+"DepDominatingVerb"+(withDirection?"WD":""), cutOff);
		this.tse=tse;
		this.withDirection=withDirection;
	}

	@Override
	public String extractStringValue(PairInstance instance, Document d) {
		int verbIndex=-1;
		Span sp=tse.getSpan(instance);
		int next=sp.s.dt.heads[sp.hd];
		while(next!=0){
			if(sp.s.tags[next].startsWith("V")){
				verbIndex=next;
				break;
			}
			next=sp.s.dt.heads[next];
		}
		if(verbIndex==-1)
			return "<null>";
		else {
			if(withDirection)
				return sp.s.forms[verbIndex]+" + "+F_DominatingVerb.direction(verbIndex,sp);
			else
				return sp.s.forms[verbIndex];
		}
	}

}
